# dungeons-and-trolls-client
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import dungeons_and_trolls_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import dungeons_and_trolls_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import dungeons_and_trolls_client
from dungeons_and_trolls_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://dt.garage-trip.cz
# See configuration.py for a list of all supported configuration parameters.
configuration = dungeons_and_trolls_client.Configuration(
    host = "https://dt.garage-trip.cz"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'


# Enter a context with an instance of the API client
with dungeons_and_trolls_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = dungeons_and_trolls_client.DungeonsAndTrollsApi(api_client)
    body = dungeons_and_trolls_client.DungeonsandtrollsAttributes() # DungeonsandtrollsAttributes | 

    try:
        # Send multiple commands to the Character bound to the logged user. The order of execution is defined in the message.
        api_response = api_instance.dungeons_and_trolls_assign_skill_points(body)
        print("The response of DungeonsAndTrollsApi->dungeons_and_trolls_assign_skill_points:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DungeonsAndTrollsApi->dungeons_and_trolls_assign_skill_points: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://dt.garage-trip.cz*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DungeonsAndTrollsApi* | [**dungeons_and_trolls_assign_skill_points**](docs/DungeonsAndTrollsApi.md#dungeons_and_trolls_assign_skill_points) | **POST** /v1/assign-skill-points | Send multiple commands to the Character bound to the logged user. The order of execution is defined in the message.
*DungeonsAndTrollsApi* | [**dungeons_and_trolls_buy**](docs/DungeonsAndTrollsApi.md#dungeons_and_trolls_buy) | **POST** /v1/buy | Buy Items identified by the provided ID for the Character bound to the logged user.
*DungeonsAndTrollsApi* | [**dungeons_and_trolls_commands**](docs/DungeonsAndTrollsApi.md#dungeons_and_trolls_commands) | **POST** /v1/commands | Send multiple commands to the Character bound to the logged user. The order of execution is defined in the message.
*DungeonsAndTrollsApi* | [**dungeons_and_trolls_game**](docs/DungeonsAndTrollsApi.md#dungeons_and_trolls_game) | **GET** /v1/game | Sends all info about the game.
*DungeonsAndTrollsApi* | [**dungeons_and_trolls_monsters_commands**](docs/DungeonsAndTrollsApi.md#dungeons_and_trolls_monsters_commands) | **POST** /v1/monsters-commands | Control monsters. Admin only.
*DungeonsAndTrollsApi* | [**dungeons_and_trolls_move**](docs/DungeonsAndTrollsApi.md#dungeons_and_trolls_move) | **POST** /v1/move | Assign skill point to the attribute for the Character bound to the logged user.
*DungeonsAndTrollsApi* | [**dungeons_and_trolls_pick_up**](docs/DungeonsAndTrollsApi.md#dungeons_and_trolls_pick_up) | **POST** /v1/pick-up | Equip the Item from the ground identified by the provided ID for the Character bound to the logged user (unused).
*DungeonsAndTrollsApi* | [**dungeons_and_trolls_register**](docs/DungeonsAndTrollsApi.md#dungeons_and_trolls_register) | **POST** /v1/register | Register provided User to the Game and create a character.
*DungeonsAndTrollsApi* | [**dungeons_and_trolls_respawn**](docs/DungeonsAndTrollsApi.md#dungeons_and_trolls_respawn) | **POST** /v1/respawn | Respawn the Character bound to the logged user.
*DungeonsAndTrollsApi* | [**dungeons_and_trolls_skill**](docs/DungeonsAndTrollsApi.md#dungeons_and_trolls_skill) | **POST** /v1/skill | Use a skill (provided by an item) by the Character bound to the logged user.
*DungeonsAndTrollsApi* | [**dungeons_and_trolls_yell**](docs/DungeonsAndTrollsApi.md#dungeons_and_trolls_yell) | **POST** /v1/yell | The Character bound to the logged user yells a messages (visible for everyone).


## Documentation For Models

 - [DungeonsandtrollsAttributes](docs/DungeonsandtrollsAttributes.md)
 - [DungeonsandtrollsCharacter](docs/DungeonsandtrollsCharacter.md)
 - [DungeonsandtrollsCommandsBatch](docs/DungeonsandtrollsCommandsBatch.md)
 - [DungeonsandtrollsCommandsForMonsters](docs/DungeonsandtrollsCommandsForMonsters.md)
 - [DungeonsandtrollsCoordinates](docs/DungeonsandtrollsCoordinates.md)
 - [DungeonsandtrollsDamageType](docs/DungeonsandtrollsDamageType.md)
 - [DungeonsandtrollsDecoration](docs/DungeonsandtrollsDecoration.md)
 - [DungeonsandtrollsDroppable](docs/DungeonsandtrollsDroppable.md)
 - [DungeonsandtrollsEffect](docs/DungeonsandtrollsEffect.md)
 - [DungeonsandtrollsEvent](docs/DungeonsandtrollsEvent.md)
 - [DungeonsandtrollsEventType](docs/DungeonsandtrollsEventType.md)
 - [DungeonsandtrollsGameState](docs/DungeonsandtrollsGameState.md)
 - [DungeonsandtrollsIdentifier](docs/DungeonsandtrollsIdentifier.md)
 - [DungeonsandtrollsIdentifiers](docs/DungeonsandtrollsIdentifiers.md)
 - [DungeonsandtrollsItem](docs/DungeonsandtrollsItem.md)
 - [DungeonsandtrollsItemType](docs/DungeonsandtrollsItemType.md)
 - [DungeonsandtrollsKey](docs/DungeonsandtrollsKey.md)
 - [DungeonsandtrollsLevel](docs/DungeonsandtrollsLevel.md)
 - [DungeonsandtrollsMap](docs/DungeonsandtrollsMap.md)
 - [DungeonsandtrollsMapObjects](docs/DungeonsandtrollsMapObjects.md)
 - [DungeonsandtrollsMessage](docs/DungeonsandtrollsMessage.md)
 - [DungeonsandtrollsMonster](docs/DungeonsandtrollsMonster.md)
 - [DungeonsandtrollsPosition](docs/DungeonsandtrollsPosition.md)
 - [DungeonsandtrollsRegistration](docs/DungeonsandtrollsRegistration.md)
 - [DungeonsandtrollsSimpleItem](docs/DungeonsandtrollsSimpleItem.md)
 - [DungeonsandtrollsSkill](docs/DungeonsandtrollsSkill.md)
 - [DungeonsandtrollsSkillAttributes](docs/DungeonsandtrollsSkillAttributes.md)
 - [DungeonsandtrollsSkillEffect](docs/DungeonsandtrollsSkillEffect.md)
 - [DungeonsandtrollsSkillFlags](docs/DungeonsandtrollsSkillFlags.md)
 - [DungeonsandtrollsSkillUse](docs/DungeonsandtrollsSkillUse.md)
 - [DungeonsandtrollsUser](docs/DungeonsandtrollsUser.md)
 - [DungeonsandtrollsWaypoint](docs/DungeonsandtrollsWaypoint.md)
 - [ProtobufAny](docs/ProtobufAny.md)
 - [ProtobufNullValue](docs/ProtobufNullValue.md)
 - [RpcStatus](docs/RpcStatus.md)
 - [SkillTarget](docs/SkillTarget.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="ApiKeyAuth"></a>
### ApiKeyAuth

- **Type**: API key
- **API key parameter name**: X-API-Key
- **Location**: HTTP header


## Author




